// ==UserScript==
// @name        Image Alt to Title Attributes
// @namespace   http://www.scss.com.au/family/andrew/opera/userjs/
// @version     1.1
// @date        2005-05-08
// @author      Andrew Gregory <andrew at scss dot com dot au>
// @description Copies image alt attributes to the title (for tooltips).
// @include     *
// ==/UserScript==
// License:     http://creativecommons.org/licenses/by-nc-sa/2.0/
// Notes:       Does not replace an existing title attribute. If the image
//              doesn't have alt text, it is given a single character (an 'X' in
//              a circle).
document.addEventListener('load', function() {
  var i, imgs, fix = function(img) {
    if (img.hasAttribute('alt')) {
      if (!img.hasAttribute('title')) {
        img.setAttribute('title', img.getAttribute('alt'));
      }
    } else {
      img.setAttribute('alt', '&otimes;');
    }
  };
  imgs = document.getElementsByTagName('img');
  for (i = 0; i < imgs.length; i++) fix(imgs[i]);
  imgs = document.getElementsByTagName('input');
  for (i = 0; i < imgs.length; i++) {
    if (imgs[i].hasAttribute('type') && imgs[i].getAttribute('type').toLowerCase() == 'image') fix(imgs[i]);
  }
}, false);
